Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet
Class ResourceServlet

    java.lang.Object
      javax.servlet.GenericServlet
          javax.servlet.http.HttpServlet
              org.springframework.web.servlet.HttpServletBean
                  org.springframework.web.servlet.ResourceServlet

All Implemented Interfaces:
  Serializable, Servlet, ServletConfig

    public class ResourceServlet

extends HttpServletBean

Simple servlet that can expose an internal resource, including a default URL if the specified resource is not found. An alternative, for example, to trying and catching exceptions when using JSP include.

A further usage of this servlet is the ability to apply last-modified timestamps to quasi-static resources (typically JSPs). This can happen as bridge to parameter-specified resources, or as proxy for a specific target resource (or a list of specific target resources to combine).

A typical usage would map a URL like "/ResourceServlet" onto an instance of this servlet, and use the "JSP include" action to include this URL, with the "resource" parameter indicating the actual target path in the WAR.

The `defaultUrl` property can be set to the internal resource path of a default URL, to be rendered when the target resource is not found or not specified in the first place.

The "resource" parameter and the `defaultUrl` property can also specify a list of target resources to combine. Those resources will be included one by one to build the response. If last-modified determination is active, the newest timestamp among those files will be used.

The `allowedResources` property can be set to a URL pattern of resources that should be available via this servlet. If not set, any target resource can be requested, including resources in the WEB-INF directory!

If using this servlet for direct access rather than via includes, the `contentType` property should be specified to apply a proper content type. Note that a content type header in the target JSP will be ignored when including the resource via a RequestDispatcher include.

To apply last-modified timestamps for the target resource, set the `applyLastModified` property to true. This servlet will then return the file timestamp of the target resource as last-modified value, falling back to the startup time of this servlet if not retrievable.

Note that applying the last-modified timestamp in the above fashion just makes sense if the target resource does not generate content that depends on the HttpSession or cookies; it is just allowed to evaluate request parameters.

A typical case for such last-modified usage is a JSP that just makes minimal usage of basic means like includes or message resolution to build quasi-static content. Regenerating such content on every request is unnecessary; it can be cached as long as the file hasn't changed.

Note that this servlet will apply the last-modified timestamp if you tell it to do so: It's your decision whether the content of the target resource can be cached in such a fashion. Typical use cases are helper resources that are not fronted by a controller, like JavaScript files that are generated by a JSP (without depending on the HttpSession).

Author:
  Juergen Hoeller, Rod Johnson
See Also:
  `setDefaultUrl(java.lang.String)`, `setAllowedResources(java.lang.String)`, `setApplyLastModified(boolean)`, Serialized Form

Field Summary
`static String` | `RESOURCE_PARAM_NAME` Name of the parameter that must contain the actual resource path.
`static String` | `RESOURCE_URL_DELIMITERS` Any number of these characters are considered delimiters between multiple resource paths in a single String value.

Fields inherited from class org.springframework.web.servlet.HttpServletBean
`logger`

Constructor Summary
`ResourceServlet()`

Method Summary
`protected String` | `determineResourceUrl(HttpServletRequest request)` Determine the URL of the target resource of this request.
`protected void` | `doGet(HttpServletRequest request, HttpServletResponse response)` Determine the URL of the target resource and include it.
`protected long` | `getFileTimestamp(String resourceUrl)` Return the file timestamp for the given resource.
`protected long` | `getLastModified(HttpServletRequest request)` Return the last-modified timestamp of the file that corresponds to the target resource URL (i.e. typically the request ".jsp" file).
`protected PathMatcher` | `getPathMatcher()` Return a PathMatcher to use for matching the "allowedResources" URL pattern.
`protected void` | `initServletBean()` Remember the startup time, using no last-modified time before it.
`void` | `setAllowedResources(String allowedResources)` Set allowed resources as URL pattern, e.g.
`void` | `setApplyLastModified(boolean applyLastModified)` Set whether to apply the file timestamp of the target resource as last-modified value.
`void` | `setContentType(String contentType)` Set the content type of the target resource (typically a JSP).
`void` | `setDefaultUrl(String defaultUrl)` Set the URL within the current web application from which to include content if the requested path isn't found, or if none is specified in the first place.

Methods inherited from class org.springframework.web.servlet.HttpServletBean
`addRequiredProperty, getServletContext, getServletName, init, initBeanWrapper`

Methods inherited from class javax.servlet.http.HttpServlet
`doDelete, doHead, doOptions, doPost, doPut, doTrace, service, service`

Methods inherited from class javax.servlet.GenericServlet
`destroy, getInitParameter, getInitParameterNames, getServletConfig, getServletInfo, init, log, log`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### RESOURCE_URL_DELIMITERS

    public static final String RESOURCE_URL_DELIMITERS

  Any number of these characters are considered delimiters between multiple resource paths in a single String value.

  See Also:
    Constant Field Values

### RESOURCE_PARAM_NAME

    public static final String RESOURCE_PARAM_NAME

  Name of the parameter that must contain the actual resource path.

  See Also:
    Constant Field Values

Constructor Detail

### ResourceServlet

    public ResourceServlet()

Method Detail

### setDefaultUrl

    public void setDefaultUrl(String defaultUrl)

  Set the URL within the current web application from which to include content if the requested path isn't found, or if none is specified in the first place.

  If specifying multiple URLs, they will be included one by one to build the response. If last-modified determination is active, the newest timestamp among those files will be used.

  See Also:
    `setApplyLastModified(boolean)`

### setAllowedResources

    public void setAllowedResources(String allowedResources)

  Set allowed resources as URL pattern, e.g. "/WEB-INF/res/*.jsp", The parameter can be any Ant-style pattern parsable by AntPathMatcher.

  See Also:
    `AntPathMatcher`

### setContentType

    public void setContentType(String contentType)

  Set the content type of the target resource (typically a JSP). Default is none, which is appropriate when including resources.

  For directly accessing resources, for example to leverage this servlet's last-modified support, specify a content type here. Note that a content type header in the target JSP will be ignored when including the resource via a RequestDispatcher include.

### setApplyLastModified

    public void setApplyLastModified(boolean applyLastModified)

  Set whether to apply the file timestamp of the target resource as last-modified value. Default is "false".

  This is mainly intended for JSP targets that don't generate session-specific or database-driven content: Such files can be cached by the browser as long as the last-modified timestamp of the JSP file doesn't change.

  This will only work correctly with expanded WAR files that allow access to the file timestamps. Else, the startup time of this servlet is returned.

### initServletBean

    protected void initServletBean()

  Remember the startup time, using no last-modified time before it.

  Overrides:
    `initServletBean` in class `HttpServletBean`

### getPathMatcher

    protected PathMatcher getPathMatcher()

  Return a PathMatcher to use for matching the "allowedResources" URL pattern. Default is AntPathMatcher.

  See Also:
    `setAllowedResources(java.lang.String)`, `AntPathMatcher`

### doGet

    protected final void doGet(HttpServletRequest request,
                               HttpServletResponse response)
                        throws ServletException,
                               IOException

  Determine the URL of the target resource and include it.

  Overrides:
    `doGet` in class `HttpServlet`
  Throws:
    `ServletException`
    `IOException`
  See Also:
    `determineResourceUrl(javax.servlet.http.HttpServletRequest)`

### determineResourceUrl

    protected String determineResourceUrl(HttpServletRequest request)

  Determine the URL of the target resource of this request.

  Default implementation returns the value of the "resource" parameter. Can be overridden in subclasses.

  Parameters:
    `request` - current HTTP request
  Returns:
    the URL of the target resource, or `null` if none found
  See Also:
    `RESOURCE_PARAM_NAME`

### getLastModified

    protected final long getLastModified(HttpServletRequest request)

  Return the last-modified timestamp of the file that corresponds to the target resource URL (i.e. typically the request ".jsp" file). Will simply return -1 if "applyLastModified" is false (the default).

  Returns no last-modified date before the startup time of this servlet, to allow for message resolution etc that influences JSP contents, assuming that those background resources might have changed on restart.

  Returns the startup time of this servlet if the file that corresponds to the target resource URL coudln't be resolved (for example, because the WAR is not expanded).

  Overrides:
    `getLastModified` in class `HttpServlet`
  See Also:
    `determineResourceUrl(javax.servlet.http.HttpServletRequest)`, `getFileTimestamp(java.lang.String)`

### getFileTimestamp

    protected long getFileTimestamp(String resourceUrl)

  Return the file timestamp for the given resource.

  Parameters:
    `resourceUrl` - the URL of the resource
  Returns:
    the file timestamp in milliseconds, or -1 if not determinable

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.